<?php

class UserSetting {
	/**
	 * @var Boolean
	 */
	public $showPoll = true;
	/**
	 * @var Boolean
	 */
	public $showLinks = true;
	/**
	 * @var Boolean
	 */
	public $showEmployee = true;
	/**
	 * @var Boolean
	 */
	public $showRecent = true;
	
	
	/**
	 * Always set default values for widgets here.
	 * @var array
	 */
	private $widgets = array('poll'=>1,'links'=>1,'employee'=>1,'news'=>1);
	private $user_id;
	public function __construct($user_id)
	{
		$this->user_id = $user_id;
		return $this;
	}
	public function getWidgets()
	{
		$table = new Zend_Db_Table(array('name'=>PrecurioTableConstants::USER_SETTING));
		$settings = $table->fetchRow($table->select()->where('user_id= ? ',$this->user_id));
		if($settings == null)return $this->createUserSettings('widgets');
		return unserialize($settings->widgets);
	}
	public function setWidgets($data)
	{
		foreach($this->widgets as $widget=>$value)
		{
			if(!isset($data[$widget]))$data[$widget] = 0;
		}
		
		
		$table = new Zend_Db_Table(array('name'=>PrecurioTableConstants::USER_SETTING));
		$settings = $table->fetchRow($table->select()->where('user_id= ? ',$this->user_id));
		$settings['widgets'] = serialize($data);
		$settings->save();
	}
	public function getBlockedUsers()
	{
		$table = new Zend_Db_Table(array('name'=>PrecurioTableConstants::USER_SETTING));
		$settings = $table->fetchRow($table->select()->where('user_id= ? ',$this->user_id));
		if($settings == null)return $this->createUserSettings('blocked_users');
		return unserialize($settings->blocked_users);
	}
	public function setBlockedUsers($data)
	{
		$table = new Zend_Db_Table(array('name'=>PrecurioTableConstants::USER_SETTING));
		$settings = $table->fetchRow($table->select()->where('user_id= ? ',$this->user_id));
		$settings['blocked_users'] = serialize($data);
		$settings->save();
	}
	private function createUserSettings($param)
	{
		$data = array();
		$data['user_id'] = $this->user_id;
		$data['widgets'] = serialize($this->widgets);
		$data['blocked_users'] = serialize(array());
		$data['date_created'] = Precurio_Date::now()->getTimestamp();
		$table = new Zend_Db_Table(array('name'=>PrecurioTableConstants::USER_SETTING));
		$row = $table->createRow($data);
		$row->save();
		return unserialize($data[$param]);
	}
	
	public function __set($name,$value)
	{
		$this->{$name} = value;
	}

}

?>