<?php

require_once ('Zend/Log.php');

class Precurio_Log extends Zend_Log {
	
	/**
	 * 
	 *@param Zend_Log_Writer_Abstract|null  $writer  default writer 
	 */
	public function __construct() {
		parent::__construct ();
		
		$dbWriter = new Zend_Log_Writer_Db(Zend_Registry::get('db'),PrecurioTableConstants::LOGS,
		array('priority'=>'priority','message'=>'message','timestamp'=>'timestamp'));
		$dbWriter->addFilter(new Zend_Log_Filter_Priority(Zend_log::INFO));//logs everything except debug messages.
		$this->addWriter($dbWriter); //enable in production mode.
		
		$debugWriter = new Zend_Log_Writer_Firebug();
		$debugWriter->addFilter(new Zend_Log_Filter_Priority(Zend_log::DEBUG,'>='));//logs only debug messages
		$this->addWriter($debugWriter);
		
	}
	/**
     * Log a message at a priority
     *
     * @param  string   $message   Message to log
     * @param  integer  $priority  Priority of message
     * @param  mixed    $extras    Extra information to log in event
     * @return void
     * @throws Zend_Log_Exception
     */
    public function log($message, $priority, $extras = null)
    {
    	try
    	{	
    		parent::log($message,$priority,$extras);
    	}
    	catch(Exception $e)
    	{
    		
    	}
    }
	

}

?>