<?php
require_once ('user/models/vo/UserActivity.php');
/**
 * This class will simply check each activity type against a set of notification 
 * channel settings.
 * @author Brain
 *
 */
class Precurio_Notification {
	
	/**
	 * @var UserActivity
	 */
	private $activity;
	
	public function __construct($activity_id)
	{
		$table = new Zend_Db_Table(array('name'=>PrecurioTableConstants::ACTIVITY, 'rowClass'=>'UserActivity'));
		$select  = $table->select(false);
		$select->setIntegrityCheck(false);
		$select = $select->from(array('a' => PrecurioTableConstants::ACTIVITY))
						->join(array('b' => PrecurioTableConstants::USERS),'a.user_id = b.user_id',array('first_name','last_name','profile_picture_id','gender'))
						->where('a.id = ? ',$activity_id);
		
		$this->activity = $table->fetchRow($select);
		//now get activity notification setting
		$rule = $this->getRule($this->activity);
		$this->applyRule($rule);
	}
	/**
	 * @return Zend_Db_Table_Row
	 */
	private function getRule($activity)
	{
		$table = new Zend_Db_Table(array('name'=>PrecurioTableConstants::NOTIFICATION_RULE));
		$rule = $table->fetchRow($table->select()->where('type= ? ',$activity->type)
													->where('active=1')
														->order('id DESC'));
		return $rule;
	}
	private function applyRule($rule)
	{
		$feed = new Precurio_Feed();
		$mail = new Precurio_Mail();
		if($rule == null)
		{
			$feed->notify($this->activity);	
			return;
		}
		if($rule->feed)
		{
			$feed->notify($this->activity);	
		}
		if($rule->email)
		{
			$mail->notify($this->activity);
		}
		//sms will follow when implemented
		return;
	}
}

?>